{{- if $.Values.openstreetmapEnabled }}
apiVersion: apps/v1
kind: Deployment
metadata:
  name: open-street-map
  namespace: {{ .Release.Namespace }}
spec:
  selector:
    matchLabels:
      app: open-street-map-container
  replicas: 1
  revisionHistoryLimit: 2
  template:
    metadata:
      labels:
        app: open-street-map-container
    spec:
      containers:
        - image: reiss611/openstreetmap-tile-server:1.3-luajit
        #- image: registry.gitlab.com/openkonsequenz/qa/openstreetmap-tile-server/main/openstreetmap-tile-server-openkonsequenz:latest
          imagePullPolicy: Always
          name: open-street-map-container
          command:
            - /bin/sh
            - -c
            - |
              chown renderer /var/lib/mod_tile/
              chown renderer /flatnodes/
              echo ********* Starting import script *********
              /run.sh import postgresql.custom.conf-import.tmpl
              echo ********* Starting openstreetmap-tile-server *********
              /run.sh run postgresql.custom.conf-run.tmpl
          env:
            - name: DOWNLOAD_PBF
              #value: https://download.geofabrik.de/europe/liechtenstein-latest.osm.pbf
              #value: https://download.geofabrik.de/europe/luxembourg-latest.osm.pbf
              value: https://download.geofabrik.de/europe/germany-latest.osm.pbf
            - name: DOWNLOAD_POLY
              #value: https://download.geofabrik.de/europe/liechtenstein.poly
              #value: https://download.geofabrik.de/europe/luxembourg.poly
              value: https://download.geofabrik.de/europe/hessen.poly
            - name: UPDATES
              value: disabled
            - name: ALLOW_CORS
              value: enabled
            - name: OSM2PGSQL_EXTRA_ARGS
              value: "-C 4048"
              #value: "-C 0 --flat-nodes /flatnodes/nodes.bin"
          ports:
            - containerPort: 80
          volumeMounts:
            - name: osm-config-volume
              mountPath: /etc/postgresql/12/main/postgresql.custom.conf-import.tmpl
              subPath: postgresql.custom.conf-import.tmpl
            - name: osm-config-volume
              mountPath: /run.sh
              subPath: run.sh
            - name: osm-config-volume
              mountPath: /etc/postgresql/12/main/postgresql.custom.conf-run.tmpl
              subPath: postgresql.custom.conf-run.tmpl
            - name: osm-data
              mountPath: /flatnodes/
              subPath: flatnodes
            - name: osm-data
              mountPath: /mapdata
              subPath: mapdata
            - name: osm-data
              mountPath: /var/lib/postgresql/12/main/
              subPath: openstreetmap-data
            - name: osm-data
              mountPath: /var/lib/mod_tile
              subPath: openstreetmap-rendered-tiles
            - name: dshm
              mountPath: /dev/shm
          resources:
            requests:
              memory: 1Gi
              cpu: 150m
            limits:
              memory: 3500Mi
              cpu: 1900m
      volumes:
        - name: osm-config-volume
          configMap:
            name: openstreetmap-config
            defaultMode: 0777
        - name: dshm
          emptyDir:
            medium: Memory
            # sizeLimit not working as expected yet, wip on kubernetes side
            # used here to replace --shm-size flag on docker side for postgresql
            sizeLimit: 1Gi
        - name: osm-data
          persistentVolumeClaim:
            claimName: osm-data
---
kind: PersistentVolumeClaim
apiVersion: v1
metadata:
  name: osm-data
  namespace: {{ .Release.Namespace }}
spec:
  storageClassName: default
  accessModes:
    - ReadWriteOnce
  resources:
    requests:
      storage: 128Gi
---
apiVersion: v1
kind: Service
metadata:
  name: open-street-map-service
  namespace: {{ .Release.Namespace }}
spec:
  selector:
    app: open-street-map-container
  ports:
    - protocol: TCP
      port: 80
      targetPort: 80
---
apiVersion: v1
kind: Pod
metadata:
  name: dataaccess
  namespace: {{ .Release.Namespace }}
spec:
  containers:
    - name: alpine
      image: alpine:latest
      command: ['sleep', 'infinity']
      volumeMounts:
        - name: osm-data
          mountPath: /data
  volumes:
    - name: osm-data
      persistentVolumeClaim:
        claimName: osm-data
{{- end }}